   'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
   'x Uhr und Alarm optmierter LCD Anschluss        xxxxxxxx
   'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx


   $regfile = "m8def.dat"
   $crystal = 16000000
   $hwstack = 100
   $swstack = 100
   $framesize = 100

   Dim Tstunde_stunde As Byte
   Dim Tminute_minute As Byte

   Dim Sekunde As Byte
   Dim Minute As Byte
   Dim Stunde As Byte
   Dim Einschalten_minute As Byte
   Dim Einschalten_stunde As Byte
   Dim Ausschalten_minute As Byte
   Dim Ausschalten_stunde As Byte




   Dim S1 As String * 2                                     'Sekunde                                  '
   Dim S2 As String * 2                                     'Minute
   Dim S3 As String * 2                                     'Stunde

   Dim S4 As String * 2                                     'Einschalten_stunde
   Dim S5 As String * 2                                     'Einschalten_minute
   Dim S6 As String * 2                                     'Ausschalten_stunde
   Dim S7 As String * 2                                     'Ausschalten_minute



   Config Lcdpin = Pin , Db7 = Portb.0 , Db6 = Portb.1 , Db5 = Portb.2 , _
      Db4 = Portb.3 , E = Portb.4 , Rs = Portb.5
   Config Lcd = 16 * 2
   Cls
   Cursor Off



   Config Timer1 = Timer , Prescale = 256
   Enable Timer1
   On Timer1 Takt
   Enable Interrupts
   Timer1 = 3036


'-----------------------------------------------


'Taster2 Uhr einstellen
Config Pind.1 = Input
Portd.1 = 1
Taster2 Alias Pind.1

'Taster3 Minuten einstellen
Config Pind.2 = Input
Portd.2 = 1
Taster3 Alias Pind.2

'Taster4  Einschalten einstellen
Config Pind.3 = Input
Portd.3 = 1
Taster4 Alias Pind.3

'Taster5 Ausschalten  einstellen
Config Pind.4 = Input
Portd.4 = 1
Taster5 Alias Pind.4

'Output Port
Config Portc.5 = Output
Relais Alias Portc.5

'LED definieren
Config Portd.6 = Output
Led Alias Portd.6

Einschalten_stunde = 00
Einschalten_minute = 00
Ausschalten_stunde = 00
Ausschalten_minute = 00

'--------------------Hauptprogramm----------------------------------------
Do

'--------------Einstellen Stunde ------------------------------------------

 Debounce Pind.1 , 0 , Stunde , Sub

'--------------Einstellen Minute ------------------------------------------

 Debounce Pind.2 , 0 , Minute , Sub






'----------- Anzeige Stunden , Minuten, Sekunden auf Display ------------------

S1 = Str(sekunde)                                           'Uhr Stunde
S1 = Format(s1 , "00")
'----------------------------------
S2 = Str(minute)                                            'Uhr Minute
S2 = Format(s2 , "00")
'------------------------------------
S3 = Str(stunde)                                            'Uhr Sekunde
S3 = Format(s3 , "00")
'--------------------------------------

S4 = Str(einschalten_stunde)                                'Einschalten_stunde
S4 = Format(s4 , "00")
'----------------------------------
S5 = Str(einschalten_minute)                                'Einschalten_minute
S5 = Format(s5 , "00")
'------------------------------------
S6 = Str(ausschalten_stunde)                                'Ausschalten_stunde
S6 = Format(s6 , "00")

S7 = Str(ausschalten_minute)                                'Ausschalten_stunde
S7 = Format(s7 , "00")



Locate 1 , 1
Lcd "Uhr: " ; S3 ; ":" ; S2 ; ":" ; S1                      'Stunde-Minute-Sekunden
Locate 2 , 1
Lcd "E:" ; S4 ; ":" ; S5 ; ; "  " ; "A:" ; S6 ; ":" ; S7    'Einschalten_stunde-Einschalten_minute/Ausschalten_stunde-Ausschalten_minute


If Taster4 = 0 Then:
   Waitms 50
   Incr Einschalten_minute
   End If

   If Einschalten_minute > 59 Then
         Einschalten_minute = 00
      End If
   If Einschalten_minute = 00 Then
         Incr Einschalten_stunde
      End If
   If Einschalten_stunde > 23 Then
         Einschalten_stunde = 00
      End If

If Taster5 = 0 Then:
   Waitms 50
   Incr Ausschalten_minute
   End If

   If Ausschalten_minute > 59 Then
         Ausschalten_minute = 00
      End If
   If Ausschalten_minute = 00 Then
         Incr Ausschalten_stunde
      End If
   If Ausschalten_stunde > 23 Then
         Ausschalten_stunde = 00
      End If


If Stunde = Einschalten_stunde And Minute = Einschalten_minute Then
Relais = 1
Led = 1
End If

If Stunde = Ausschalten_stunde And Minute = Ausschalten_minute Then
Relais = 0
Led = 0
End If

Loop
End



Takt:
Timer1 = 3036
Incr Sekunde
If Sekunde = 60 Then
   Sekunde = 0
   Minute = Minute + 1
         If Minute = 60 Then
         Minute = 0
         Stunde = Stunde + 1
           If Stunde > 23 Then
           Stunde = 0
           End If
         End If
End If


Return
'------------SUB Einstellen Stunde ----------------------------------------
Stunde:
   Waitms 50
   Incr Stunde
         If Stunde > 23 Then
         Stunde = 00
         End If
Return

'------------SUB Einstellen Minute-----------------------------------------
Minute:
   Waitms 50
   Incr Minute
         If Minute > 59 Then
         Minute = 00
         End If
Return

'------------SUB Einschalten  einstellen-----------------------------------


'------------SUB Einstellen Alarm Minute----------------------------------
Ausschalten:
   Waitms 50
   Incr Ausschalten_minute
         If Ausschalten_minute > 59 Then
         Ausschalten_minute = 00
         Ausschalten_stunde = Ausschalten_stunde + 1
         End If
         If Ausschalten_stunde > 23 Then
         Ausschalten_stunde = 00
         End If
Return